var FrozenTissueDate = function()
{
	var ftd = {};
	var debug = 0;
	
	var warnings;

	ftd.initPage = function()
	{
		// Step 1
		Events.addEventHandler('step-1', 'wizard-validate', ftd.validateStep1);
		Wizard.initFileSelectionField('importfile');
		
		// Navigation
		Buttons.addClickHandler('gocancel', Wizard.cancelWizard);
		Buttons.addClickHandler('gorestart', Wizard.restartWizard);
		Buttons.addClickHandler('goimport', Wizard.goRegister);
		Buttons.addClickHandler('showAllWarnings', ftd.showAllWarnings);
		
		// Final registration
		Events.addEventHandler('wizard', 'wizard-submit', ftd.submit);

		Doc.show('step-1');
		Doc.show('goimport');
	}
	
	ftd.validateStep1 = function(event)
	{
		var valid = true;
		valid &= Wizard.isValid('importfile');
		if (!valid) event.preventDefault();
	}

	ftd.submit = function()
	{
		var frm = document.forms['reggie'];
		
		var url = '../Import.servlet?ID='+App.getSessionId();
		url += '&cmd=ImportFrozenTissueDate';
		url += '&file='+encodeURIComponent(frm.importfile.value);
		url += '&progressbar=import-frozen-tissue-progress';
		
		Wizard.showLoadingAnimation('Importing FrozenTissueDate...', 'import-frozen-tissue-progress');
		Wizard.asyncJsonRequest(url, ftd.submissionResults, 'POST');
	}
	
	ftd.submissionResults = function(response)
	{
		Wizard.showFinalMessage(response.messages);
		
		warnings = response.warnings;
		
		var oldWarnings = 0;
		if (warnings && warnings.length)
		{
			oldWarnings = ftd.createWarningsTable(warnings);
			if (oldWarnings > 0)
			{
				Doc.show('showAllWarnings');
			}
		}
		
		Doc.show('gorestart');
	}

	ftd.createWarningsTable = function(warnings)
	{
		var html = '';
		var numOldWarnings = 0;
		for (var warningNo = 0; warningNo < warnings.length; warningNo++)
		{
			var warning = warnings[warningNo];
			if (!warning.isNew) numOldWarnings++;
			html += '<tr class="highlight '+(warning.isNew ? 'newwarning' : 'oldwarning')+'">';
			html += '<td>'+warning.line+'</td>';
			html += '<td>'+Strings.encodeTags(warning.reason)+'</td>';
			html += '<td>'+Strings.encodeTags(warning.provId);
			if (warning.caseName)
			{
				html += '<img class="link case-summary" data-name="'+Strings.encodeTags(warning.caseName)+'" src="../images/case_summary.png">';
			}
			html += '</td>';
			html += '<td>'+Strings.encodeTags(warning.comment)+'</td>';
			html += '</tr>';
		}
		Doc.element('import-warnings').innerHTML = html;
		
		var cs = document.getElementsByClassName('case-summary');
		for (var i = 0; i < cs.length; i++)
		{
			Events.addEventHandler(cs[i], 'click', Reggie.openCaseSummaryPopupOnEvent);
		}
		
		if (numOldWarnings < warnings.length)
		{
			// There is at least one new warning
			Doc.show('warnings-section');
		}

		return numOldWarnings;
	}
	
	ftd.showAllWarnings = function()
	{
		Doc.hide('showAllWarnings');
		Doc.show('warnings-section');
		Doc.removeClass('warnings-section', 'hide-old-warnings');
	}
	
	return ftd;
}();

Doc.onLoad(FrozenTissueDate.initPage);

