var CreatePool = function()
{
	var createpool = {};
	var debug = 0;
	
	var targetVolumePerLibIsValid = [];
	var POOL_DATA = [];
	var USED_POOL_NAMES = [];

	// Loaded from servlet when getting Library information
	var LIMIT_FOR_AUTO_EXCLUDE = 0.25;
	var LIMIT_FOR_EXTRA_LARGE_MIX;
	var MAX_TARGET_VOLUME = 20;
	var MIN_TARGET_VOLUME = 2;

	var LIBRARY_FRAC_ADPT_LIMIT = 10; // percent

	
	// Page initialization
	createpool.initPage = function()
	{
		// Step 1
		Events.addEventHandler('step-1', 'wizard-validate', createpool.validateStep1);
		Buttons.addClickHandler('btnCreateManualPool', createpool.createManualPool);
		Buttons.addClickHandler('btnCreateManualPool2', createpool.createManualPool);
		
		// Step 2
		Events.addEventHandler('step-2', 'wizard-initialize', createpool.initializeStep2);
		Events.addEventHandler('step-2', 'wizard-validate', createpool.validateStep2);
		Buttons.addClickHandler('btnExcludeFromPool', createpool.excludeSelected);
		Buttons.addClickHandler('btnIncludeInPool', createpool.includeSelected);
		Buttons.addClickHandler('btnSetTargetVolume', createpool.setTargetVolume);
		Buttons.addClickHandler('btnFlag', createpool.toggleFlag);
		Buttons.addClickHandler('btnComment', createpool.commentSelected);
	
		// Right-click menu
		Events.addEventHandler('plate', 'mouseup', createpool.contextEvent);
		Events.addEventHandler('plate', 'contextmenu', createpool.contextEvent);
		Events.addEventHandler('mnuExcludeFromPool', 'click', createpool.excludeSelected);
		Events.addEventHandler('mnuIncludeInPool', 'click', createpool.includeSelected);
		Events.addEventHandler('mnuSetTargetVolume', 'click', createpool.setTargetVolume);
		Events.addEventHandler('mnuFlag', 'click', createpool.toggleFlag);
		Events.addEventHandler('mnuComment', 'click', createpool.commentSelected);
		Events.addEventHandler('mnuCaseSummary', 'click', createpool.showCaseSummary);
		Events.addEventHandler(document, 'click', createpool.forgetContext);
		
		// Navigation
		Buttons.addClickHandler('gocancel', Wizard.cancelWizard);
		Buttons.addClickHandler('gorestart', Wizard.restartWizard);
		Buttons.addClickHandler('gonext', Wizard.goNextOnClick);
		Buttons.addClickHandler('goregister', Wizard.goRegister);
		
		// Final registration
		Events.addEventHandler('wizard', 'wizard-submit', createpool.submit);

		var url = '../Pool.servlet?ID='+App.getSessionId();
		url += '&cmd=GetLibraryPlatesForPooling';
		Wizard.showLoadingAnimation('Loading library plates...');
		Wizard.asyncJsonRequest(url, createpool.libPlateInfoLoaded);
	}
	
	createpool.libPlateInfoLoaded = function(response)
	{
		var frm = document.forms['reggie'];

		var bioplates = response.bioplates;
		var plates = frm.bioplate;
		if (bioplates.length > 0)
		{
			for (var i=0; i < bioplates.length; i++)
			{
				var bioplate = bioplates[i];
				var option = new Option(bioplate.name, bioplate.id);
				option.bioplate = bioplate;
				plates.options[plates.length] = option;
			}
			bioplateIsValid = true;
			Wizard.setInputStatus('bioplate', 'valid');
		}
		else
		{
			Wizard.setFatalError('No Library bioplates available for processing.');
			Doc.show('btnCreateManualPool2');
			Doc.hide('gorestart');
			return;
		}

		Doc.show('step-1');
		Doc.show('gonext');
	}
		
	createpool.createManualPool = function()
	{
		location.replace('create_manual_pool.jsp?ID='+App.getSessionId());
	}
	
	createpool.validateStep1 = function(event)
	{}

	createpool.initializeStep2 = function()
	{
		var frm = document.forms['reggie'];
		var libPlate = frm.bioplate[frm.bioplate.selectedIndex].bioplate;
		var schema = PoolSchema.getById(libPlate.poolSchema);
		var isNeoPrep = libPlate.isNeoPrep;
		var columns = libPlate.columns;
		var rows = libPlate.rows;
		
		var html = '<tr id="pool-row"></tr>';
		html += '<tr class="header">';
		html += '<th></th>';
		for (var c = 0; c < columns; c++)
		{
			html += '<th id="col.'+c+'">'+(c+1)+'</th>';
		}
		if (isNeoPrep)
		{
			html += '<th></th>';
		}
		html += '</tr>';
		html += '<tbody>';
		
		for (var r = 0; r < rows; r++)
		{
			html += '<tr class="row-'+r+'">';
			html += '<th id="row.'+r+'" class="rowheader">'+(isNeoPrep ? (r+1)+'L' : Reggie.wellToAlpha(r))+'</th>';

			for (var c = 0; c < columns; c++)
			{
				html += '<td class="well col-'+c+'" id="well.'+r+'.'+c+'"';
				html += ' data-col="'+c+'" data-row="'+r+'"';
				html += ' title="Select/deselect this well"></td>';
			}
			if (isNeoPrep)
			{
				html += '<th id="row.'+r+'.2" class="rowheader">'+(r+9)+'L</th>';
			}
			html += '</tr>';
		}
		html += '</tbody>';
		Doc.element('plate').innerHTML = html;
		
		var wells = Doc.element('plate').getElementsByClassName('well');
		for (var i = 0; i < wells.length; i++)
		{
			Events.addEventHandler(wells[i], 'click', createpool.toggleWell);
		}
		
		var url = '../Pool.servlet?ID='+App.getSessionId();
		url += '&cmd=GetNextAutoGeneratedPoolNames&numNames='+schema.numPools;		
		Wizard.showLoadingAnimation('Loading information about pools...');
		Wizard.asyncJsonRequest(url, createpool.poolNamesLoaded);
	}
	
	createpool.poolNamesLoaded = function(response)
	{
		var list = response.names;
		for (var i = 0; i < list.length; i++)
		{
			POOL_NAMES[i] = list[i];
		}

		var frm = document.forms['reggie'];
		var libPlate = frm.bioplate[frm.bioplate.selectedIndex].bioplate;
		var url = '../Pool.servlet?ID='+App.getSessionId();
		url += '&cmd=GetLibraryInfoForPlate&bioplate='+libPlate.id;		
		Wizard.showLoadingAnimation('Loading information about libraries...');
		Wizard.asyncJsonRequest(url, createpool.libraryInfoLoaded);
	}
	
	createpool.libraryInfoLoaded = function(response)
	{
		var frm = document.forms['reggie'];
		var libPlate = frm.bioplate[frm.bioplate.selectedIndex].bioplate;

		var schema = PoolSchema.getById(libPlate.poolSchema);
		var barcodeVariant = PoolSchema.getBarcodeVariantByName(schema, libPlate.barcodeVariant);
		Plate.setPoolSchema(schema);
		WellPainter.barcodeVariant = barcodeVariant;
		WellPainter.plate = libPlate;
		Plate.init(libPlate.rows, libPlate.columns, schema, WellPainter);

		var poolInfo = response.poolInfo;
		LIMIT_FOR_EXTRA_LARGE_MIX = poolInfo.limitForExtraLargeMix;
		var libs = response.libraries;
		var molarityLimit = poolInfo.targetMolarity * LIMIT_FOR_AUTO_EXCLUDE;
		for (var i = 0; i < libs.length; i++)
		{
			var lib = libs[i];
			var well = lib.bioWell;
			lib.excludeFromPool = false;
			lib.isYellow = lib.specimen && lib.specimen.YellowLabel != null;
			
			if (lib.molarity != null && lib.molarity < molarityLimit)
			{
				lib.excludeFromPool = true;
				lib.flag = 'ExcludedFromPool';
				lib.comment = 'Not enough DNA';
			}
	
			Plate.getWell(well.row, well.column).setExtract(lib);
		}

		Wizard.setCurrentStep(2);
		Doc.show('gocancel');
		Doc.show('goregister');
		
		PoolSchema.buildPoolTableRow(schema, libPlate.columns, false, null, libPlate.isNeoPrep ? '<th></th>' : null);
		createpool.initPoolData(poolInfo.targetVolumePerLib);
		createpool.updatePoolData();
	}

	createpool.initPoolData = function(targetVolumePerLib)
	{
		var usePoolNo = -1;
		for (var poolNo = 0; poolNo < Plate.getPools(); poolNo++)
		{
			// Count libs
			var numLibs = 0;
			var wells = Plate.getPool(poolNo);
			for (var wellNo = 0; wellNo < wells.length; wellNo++)
			{
				var well = wells[wellNo];
				var lib = well.extract;
				if (lib)
				{
					numLibs++;
				}
			}
			
			var poolDiv = Doc.element('pool.'+poolNo);
			if (numLibs > 0)
			{
				usePoolNo++;
				USED_POOL_NAMES[poolNo] = POOL_NAMES[usePoolNo];
				var html = '';
				html += '<div class="pool-name">'+Strings.encodeTags(USED_POOL_NAMES[poolNo])+'</div>';
				html += '<div class="pool-data">';
				html += '<table class="step-form">';
				html += '<tr><td class="prompt">Pool molarity</td>';
				html += '<td><select name="target_molarity.'+poolNo+'" id="target_molarity.'+poolNo+'" style="width: 4em;">';
				html += '<option value="1">1.0';
				html += '<option value="2" selected>2.0';
				html += '</select> nM</td>';
				html += '<td id="target_molarity.'+poolNo+'.status" class="status">&nbsp;</td></tr>';
				html += '<tr><td class="prompt">Volume/lib</td>';
				html += '<td><input type="text" name="target_volume.'+poolNo+'" id="target_volume.'+poolNo+'"';
				html += ' style="width: 4em;" value="'+targetVolumePerLib+'">';
				html += ' µl ('+MIN_TARGET_VOLUME+'--'+MAX_TARGET_VOLUME+')</td>';
				html += '<td id="target_volume.'+poolNo+'.status" class="status">&nbsp;</td></tr>';
				html += '<tr><td class="prompt">Mixing strategy</td>';
				html += '<td colspan="2">';
				html += '<label><input type="radio" name="mixing_strategy.'+poolNo+'" id="mixing_strategy.'+poolNo+'.dynamic"';
				html += ' value="dynamic" checked>Dynamic</label> ';
				html += '<label><input type="radio" name="mixing_strategy.'+poolNo+'" id="mixing_strategy.'+poolNo+'.fixed"';
				html += ' value="fixed">Fixed</label>';
				html += '</td></tr>';
				html += '</table>';
				
				html += '<textarea name="comment.'+poolNo+'"></textarea>';
				html += '</div>';
				html += '<div class="pool-summary" id="pool-summary.'+poolNo+'"></div>';
				poolDiv.innerHTML = html;
				createpool.setTargetVolumePerLib(poolNo, targetVolumePerLib);
			}
			else
			{
				poolDiv.innerHTML = '';
			}
		}
		
		for (var poolNo = 0; poolNo < Plate.getPools(); poolNo++)
		{
			Events.addEventHandler('target_molarity.'+poolNo, 'change', createpool.targetMolarityOnChange);
			Events.addEventHandler('target_volume.'+poolNo, 'keypress', Events.numberOnly);
			Events.addEventHandler('target_volume.'+poolNo, 'change', createpool.targetVolumeOnChange);
			Events.doOnEnter('target_volume.'+poolNo, createpool.targetVolumeOnChange);

			Events.addEventHandler('mixing_strategy.'+poolNo+'.dynamic', 'click', createpool.mixingStrategyOnChange);
			Events.addEventHandler('mixing_strategy.'+poolNo+'.fixed', 'click', createpool.mixingStrategyOnChange);
		}
	}
	
	createpool.setTargetVolumePerLib = function(poolNo, targetVolumePerLib)
	{
		var frm = document.forms['reggie'];
		if (targetVolumePerLib)
		{
			frm['target_volume.'+poolNo].value = targetVolumePerLib;
		}
		else
		{
			targetVolumePerLib = parseInt(frm['target_volume.'+poolNo].value);
		}
		
		targetVolumePerLibIsValid[poolNo] = false;
		if (targetVolumePerLib < MIN_TARGET_VOLUME || targetVolumePerLib > MAX_TARGET_VOLUME)
		{
			Wizard.setInputStatus('target_volume.'+poolNo, 'invalid', 'Must be between '+MIN_TARGET_VOLUME+' and '+MAX_TARGET_VOLUME+'µl');
			return;
		}
		
		Wizard.setInputStatus('target_volume.'+poolNo, 'valid');
		targetVolumePerLibIsValid[poolNo] = true;

		// Pre-process the Library items
		var mixingStrategy = Forms.getCheckedRadio(frm['mixing_strategy.'+poolNo]).value;
		var targetMolarityInPool = parseFloat(frm['target_molarity.'+poolNo].value);
		var wells = Plate.getPool(poolNo);
		for (var i = 0; i < wells.length; i++)
		{
			var lib = wells[i].extract;
			if (lib)
			{
				if (lib.remainingQuantity == null)
				{
					lib.excludeFromPool = true;
				}
				else
				{
					PoolMix.calculateLibVolume(lib, targetMolarityInPool, targetVolumePerLib, mixingStrategy);
					PoolMix.calculateEbVolume(lib, targetMolarityInPool, targetVolumePerLib, mixingStrategy);
				}
			}
		}
	}
	
	createpool.targetVolumeOnChange = function(event)
	{
		var frm = document.forms['reggie'];
		var poolNo = parseInt(event.target.name.substr(-1));
		createpool.setTargetVolumePerLib(poolNo);
		createpool.updatePoolData();
	}
	
	createpool.mixingStrategyOnChange = function(event)
	{
		createpool.targetVolumeOnChange(event);
	}
	
	createpool.targetMolarityOnChange = function(event)
	{
		createpool.targetVolumeOnChange(event);
	}
	
	createpool.calculateRemarks = function(plate, lib, schema, barcodeVariant)
	{
		var well = lib.bioWell;
		var remarks = [];

		// Check if default barcode has been modified
		var indexSet = barcodeVariant.indexSets[well.column];
		if (indexSet)
		{
			var defaultBarcode = indexSet.barcodes[well.row];
			if (defaultBarcode && lib.barcode.name != defaultBarcode)
			{
				remarks[remarks.length] = 'Modified barcode';
				lib.barcode.modified = true;
			}
		}
		
		if (lib.molarity != null)
		{
			if (lib.volume != lib.actualVolume)
			{
				if (lib.volume > lib.remainingVolume)
				{
					remarks[remarks.length] = 'Low quantity';
				}
				else 
				{
					remarks[remarks.length] = 'Low molarity';
				}
			}

			if (lib.speedVacConc != null)
			{
				remarks[remarks.length] = 'SpeedVac';
			}
			
			if (lib.mixFactor > 1)
			{
				// Larger mix than default
				remarks[remarks.length] = 'Use ' + Numbers.formatNumber(lib.actualVolume+lib.actualEb, 1, 'µl') + ' in pool';
			}
			
		}
		
		if (!plate.isNeoPrep)
		{
			if (lib.libraryFracAdpt == null)
			{
				remarks[remarks.length] = 'Unknown adapter fraction';
			}
			else if (lib.libraryFracAdpt > LIBRARY_FRAC_ADPT_LIMIT)
			{
				remarks[remarks.length] = 'High adapter fraction';
			}
		}
		
		lib.stratagene = Reggie.isStratagene(lib.name);
		lib.external = Reggie.isExternal(lib.name);
		lib.remarks = remarks;
	}

	
	createpool.updatePoolData = function()
	{
		var frm = document.forms['reggie'];

		var libPlate = frm.bioplate[frm.bioplate.selectedIndex].bioplate;
		var schema = PoolSchema.getById(libPlate.poolSchema);
		var barcodeVariant = PoolSchema.getBarcodeVariantByName(schema, libPlate.barcodeVariant);

		for (var poolNo = 0; poolNo < Plate.getPools(); poolNo++)
		{
			var numSeparateMix = 0;
			var numLowQuantity = 0;
			var numExcluded = 0;
			
			// Get all libs into an array
			var libs = [];
			var wells = Plate.getPool(poolNo);
			for (var wellNo = 0; wellNo < wells.length; wellNo++)
			{
				var well = wells[wellNo];
				var lib = well.extract;
				if (lib)
				{
					if (lib.excludeFromPool)
					{
						numExcluded++;
					}
					else
					{
						libs[libs.length] = lib;
					}
				}
			}
			
			if (libs.length == 0)
			{
				// There are no libs in this pool...
				Plate.paint(wells);
				continue;
			}
			
			// Calculate final pool volumes, molarity, etc.
			var targetVolumePerLib = parseFloat(frm['target_volume.'+poolNo].value);
			var mixingStrategy = Forms.getCheckedRadio(frm['mixing_strategy.'+poolNo]).value;
			var targetMolarityInPool = parseFloat(frm['target_molarity.'+poolNo].value);
			var poolInfo = PoolMix.calculateFinalPoolInfo(libs, targetMolarityInPool, targetVolumePerLib, mixingStrategy);
			POOL_DATA[poolNo] = poolInfo;
			
			// Make remarks for each lib
			for (var libNo = 0; libNo < libs.length; libNo++)
			{
				var lib = libs[libNo];
				createpool.calculateRemarks(libPlate, lib, schema, barcodeVariant);
				if (lib.eb != 0 || mixingStrategy == 'fixed') numSeparateMix++;
				if (lib.volume > lib.actualVolume) numLowQuantity++;
			}
			
			Plate.paint(wells);

			var warnMsg = null;
			if (poolInfo.ebVolumeExtra < 0) 
			{
				warnMsg = 'Too many libs with low molarity';
			}
			
			var poolDiv = Doc.element('pool.'+poolNo);
			var summaryDiv = Doc.element('pool-summary.'+poolNo);
			var poolData = '';
			poolData += libs.length + ' libs • ';
			poolData += Numbers.formatNumber(poolInfo.molarity, 2, 'nM')+' • ';
			poolData += Numbers.formatNumber(poolInfo.totalVolume, 1, 'µl');
			if (mixingStrategy == 'dynamic')
			{
				poolData += ' • <span class="pool-eb">'+Numbers.formatNumber(poolInfo.ebVolumeExtra, 1, 'µl')+'</span>';
			}
			if (numSeparateMix > 0 || numLowQuantity)
			{
				poolData += '<br>Separate mix: ' + numSeparateMix;
				poolData += ' • Low quantity: ' + numLowQuantity;
				poolData += '';
			}
			
			if (warnMsg)
			{
				Doc.addClass(poolDiv, 'warning');
				poolData += '<div class="warning-message">'+warnMsg+'</div>';
			}
			else
			{
				Doc.removeClass(poolDiv, 'warning');
			}
			summaryDiv.innerHTML = poolData;
		}
	}

	var contextWell = null;
	var contextX;
	var contextY;
	createpool.forgetContext = function()
	{
		contextWell = null;
	}

	/**
		Reacts to 'mouseup' and 'contextmenu' events for the bioplate. 
		This should bring up the cut/copy/paste context menu depending on which
		mouse button that was clicked.
	*/
	createpool.contextEvent = function(event)
	{
		var frm = document.forms['reggie'];
		// Context menu on 'right' mouse button
		// Can't just check the button since two events are sent ('mouseup' and 'contextmenu')
		var showContext = event.type == 'contextmenu' && event.button == 2;
			
		if (showContext)
		{
			event.preventDefault(); // Prevents the default right-click menu from appearing
			
			// Get the well that is right-clicked and the Library that is in it
			contextWell = null;
			var well = event.target;
			while (well && (!well.id || well.id.indexOf('well') != 0))
			{
				well = well.parentNode;
			}
			if (well)
			{
				var c = well.id.split(/\./);
				var tmp = Plate.getWell(parseInt(c[1]), parseInt(c[2]));
				if (tmp.extract) contextWell = tmp;
			}
			
			if (!contextWell) return;
			
			// Update the context meny
			var caseSummaryMenu = Doc.element('mnuCaseSummary');
			if (contextWell)
			{
				caseSummaryMenu.title = 'Show case summary for ' + Strings.encodeTags(contextWell.extract.name);
				Doc.show('sepCaseSummary');
				Doc.show('mnuCaseSummary');
			}
			else
			{
				Doc.hide('sepCaseSummary');
				Doc.hide('mnuCaseSummary');
			}
			
			var menu = Doc.element('menuContext');
			// 1 pixel offset to avoid losing well focus outline
			contextX = event.clientX+1;
			contextY = event.clientY+1;
			// Need short delay since 'mouseup' are also sent as 'click' events
			// to the 'document' object which BASE already have a Menu.hideAll()
			// call which would hide the menu immediately
			App.debug('show-context:'+contextX+':'+contextY+':'+contextWell);
			setTimeout(createpool.showContextMenu, 100);
		}
	}
	
	createpool.showContextMenu = function()
	{
		Menu.showTopMenu('menuContext', contextX, contextY);
	}
	
	createpool.showCaseSummary = function()
	{
		if (!contextWell) return;
		Reggie.openCaseSummaryPopup(contextWell.extract.name);
	}
	
	createpool.validateStep2 = function(event)
	{
		var numPools = Plate.getPools();
		for (var poolNo = 0; poolNo < numPools; poolNo++)
		{
			if (USED_POOL_NAMES[poolNo] && !targetVolumePerLibIsValid[poolNo]) 
			{
				event.preventDefault();
				return;
			}
		}
	}
	
	createpool.submit = function()
	{
		var frm = document.forms['reggie'];

		var submitInfo = {};
		submitInfo.pools = [];
		submitInfo.flagged = [];

		var libPlate = frm.bioplate[frm.bioplate.selectedIndex].bioplate;

		var numPools = Plate.getPools();
		for (var poolNo = 0; poolNo < numPools; poolNo++)
		{
			if (!USED_POOL_NAMES[poolNo])
			{
				continue;
			}
			var wells = Plate.getPool(poolNo);
			
			var poolInfo = {};
			poolInfo.name = USED_POOL_NAMES[poolNo];
			poolInfo.targetPoolMolarity = parseFloat(frm['target_molarity.'+poolNo].value);
			poolInfo.targetVolumeInPoolPerLib = parseFloat(frm['target_volume.'+poolNo].value);
			var mixingStrategy = Forms.getCheckedRadio(frm['mixing_strategy.'+poolNo]).value;
			poolInfo.mixingStrategy = mixingStrategy;
			poolInfo.comment = frm['comment.'+poolNo].value;
			poolInfo.ebVolumeExtra = POOL_DATA[poolNo].ebVolumeExtra;
			poolInfo.libPlate = libPlate.id;
			poolInfo.libs = [];
			poolInfo.excluded = [];
				
			for (var wellNo = 0; wellNo < wells.length; wellNo++)
			{
				var lib = wells[wellNo].extract;
				if (lib)
				{
					// We send library id, name and mixin volumes
					var tmp = {};
					tmp.id = lib.id;
					tmp.name = lib.name;
					tmp.volume = lib.actualVolume; 
					tmp.eb = lib.actualEb;
					tmp.mixFactor = lib.mixFactor;
					if (lib.mixFactor > 1 && lib.targetVolume && mixingStrategy == 'dynamic') 
					{
						tmp.targetVolume = lib.targetVolume;
					}
					tmp.comment = lib.comment;
						
					if (lib.excludeFromPool)
					{
						poolInfo.excluded[poolInfo.excluded.length] = tmp;
					}
					else
					{
						poolInfo.libs[poolInfo.libs.length] = tmp;
					}
						
					if (lib.flag)
					{
						tmp.flag = lib.flag;
						submitInfo.flagged[submitInfo.flagged.length] = tmp;
					}
				}
			}
			
			submitInfo.pools[submitInfo.pools.length] = poolInfo;
		}

		var url = '../Pool.servlet?ID='+App.getSessionId();
		url += '&cmd=CreatePools';
		Wizard.showLoadingAnimation('Performing registration...');
		Wizard.asyncJsonRequest(url, createpool.submissionResults, 'POST', JSON.stringify(submitInfo));
	}
	
	createpool.submissionResults = function(response)
	{
		Wizard.showFinalMessage(response.messages);
		Doc.show('gorestart');
	}

	createpool.initElements = function(element, autoInit)
	{
		if (autoInit == 'plate-well')
		{
			Events.addEventHandler(element, 'click', createpool.toggleWell);
		}
	}

	//Toggle the selected status of a single well
	createpool.toggleWell = function(event)
	{
		var row = Data.int(event.currentTarget, 'row');
		var column = Data.int(event.currentTarget, 'col');
		var well = Plate.getWell(row, column);
		Plate.toggleSelected([well]);
	}
	
	var lastComment = '';
	createpool.excludeSelected = function(event)
	{
		var wells = Plate.getSelected();
		if (wells.length == 0 && contextWell) wells = [ contextWell ];
		if (wells.length == 0)
		{
			Forms.showNotification(event.currentTarget, 'No wells have been selected');
			return;
		}

		// See if there is an existing comment
		var comment;
		for (var i = 0; i < wells.length; i++)
		{
			var lib = wells[i].extract;
			if (lib && lib.comment) 
			{
				comment = lib.comment;
			}
		}

		comment = prompt('Comment on reason for exclusion', comment || lastComment);
		if (comment == null) return;
		lastComment = comment;
		
		if (comment == '') comment = null;
		
		for (var i = 0; i < wells.length; i++)
		{
			var well = wells[i];
			var lib = well.extract;
			if (lib)
			{
				lib.excludeFromPool = true;
				if (!lib.stratagene && !lib.external)
				{
					lib.flag = 'ExcludedFromPool';
					lib.comment = comment;
				}
			}
			well.selected = false;
		}
		
		createpool.updatePoolData();
	}

	createpool.includeSelected = function(event)
	{
		var wells = Plate.getSelected();
		if (wells.length == 0 && contextWell) wells = [ contextWell ];
		if (wells.length == 0)
		{
			Forms.showNotification(event.currentTarget, 'No wells have been selected');
			return;
		}

		for (var i = 0; i < wells.length; i++)
		{
			var well = wells[i];
			var lib = well.extract;
			if (lib)
			{
				lib.excludeFromPool = false;
				lib.flag = null;
				lib.oldComment = lib.comment;
				lib.comment = null;
			}
			well.selected = false;
		}
		createpool.updatePoolData();
	}

	
	//Flag the selected RNA
	createpool.toggleFlag = function(event)
	{
		var wells = Plate.getSelected();
		if (wells.length == 0 && contextWell) wells = [ contextWell ];
		if (wells.length == 0)
		{
			Forms.showNotification(event.currentTarget, 'No wells have been selected');
			return;
		}

		var flag = null;
		var firstLib = true;
		for (var i = 0; i < wells.length; i++)
		{
			var well = wells[i];
			var lib = well.extract;
			if (lib)
			{
				if (firstLib && !lib.excludeFromPool)
				{
					flag = lib.flag ? null : 'ManualFlag';
					firstLib = false;
				}
				lib.flag = lib.excludeFromPool ? 'ExcludedFromPool' : flag;
			}
			//well.selected = false;
		}
		createpool.updatePoolData();
	}

	//Set a comment on the selected wells
	createpool.commentSelected = function(event)
	{
		var wells = Plate.getSelected();
		if (wells.length == 0 && contextWell) wells = [ contextWell ];
		if (wells.length == 0)
		{
			Forms.showNotification(event.currentTarget, 'No wells have been selected');
			return;
		}
			
		var count = 0;
		var comment;
		for (var i = 0; i < wells.length; i++)
		{
			var well = wells[i];
			if (well.extract) 
			{
				if (well.extract.comment) comment = well.extract.comment;
				count++;
			}
		}
			
		if (count == 0)
		{
			Forms.showNotification(event.currentTarget, 'Only empty wells have been selected');
			return;
		}
			
		comment = prompt('Comment', comment || lastComment);
		if (comment == null) return;
			
		lastComment = comment;
		
		if (comment == '') comment = null;
		for (var i = 0; i < wells.length; i++)
		{
			var well = wells[i];
			if (well.extract) 
			{
				well.extract.comment = comment;
			}
			well.selected = false;
		}
		
		createpool.updatePoolData();
	}
	
	//Set target volume on the selected wells
	var lastTargetVolume = null;
	createpool.setTargetVolume = function(event)
	{
		var frm = document.forms['reggie'];

		var wells = Plate.getSelected();
		if (wells.length == 0 && contextWell) wells = [ contextWell ];
		if (wells.length == 0)
		{
			Forms.showNotification(event.currentTarget, 'No wells have been selected');
			return;
		}
			
		var count = 0;
		var targetVolume;
		for (var i = 0; i < wells.length; i++)
		{
			var well = wells[i];
			if (well.extract && well.extract.mixFactor > 1) 
			{
				if (well.extract.targetVolume) 
				{
					targetVolume = well.extract.targetVolume;
				}
				else
				{
					var poolNo = Plate.poolSchema.getPoolNumForColumn(well.column);
					targetVolume = parseFloat(frm['target_volume.'+poolNo].value);
				}
				count++;
			}
		}
			
		if (count == 0)
		{
			Forms.showNotification(event.currentTarget, 'Only empty or dynamic-mixed wells have been selected');
			return;
		}
			
		targetVolume = parseFloat(prompt('Volume to use in pool ('+LIMIT_FOR_EXTRA_LARGE_MIX+'--'+MAX_TARGET_VOLUME+' µl)', targetVolume || lastTargetVolume || D));
		if (isNaN(targetVolume))
		{
			targetVolume = null;
		}
		else if (targetVolume > MAX_TARGET_VOLUME)
		{
			targetVolume = MAX_TARGET_VOLUME;
		}
		else if (targetVolume < LIMIT_FOR_EXTRA_LARGE_MIX)
		{
			targetVolume = LIMIT_FOR_EXTRA_LARGE_MIX
		}
	
		
		lastTargetVolume = targetVolume;
		
		if (targetVolume == '') targetVolume = null;
		var frm = document.forms['reggie'];
		for (var i = 0; i < wells.length; i++)
		{
			var well = wells[i];
			if (well.extract) 
			{
				var lib = well.extract;
				lib.targetVolume = targetVolume;
				var poolNo = Plate.poolSchema.getPoolNumForColumn(lib.bioWell.column);
				
				var targetVolumePerLib = parseFloat(frm['target_volume.'+poolNo].value);
				var mixingStrategy = Forms.getCheckedRadio(frm['mixing_strategy.'+poolNo]).value;
				var targetMolarityInPool = parseFloat(frm['target_molarity.'+poolNo].value);
				PoolMix.calculateEbVolume(lib, targetMolarityInPool, targetVolumePerLib, mixingStrategy);
			}
			well.selected = false;
		}
		
		createpool.updatePoolData();
	}


	return createpool;
}();

Doc.onLoad(CreatePool.initPage);
Doc.addElementInitializer(CreatePool.initElements);

var WellPainter = function()
{
	var painter = {};
	
	painter.getClassNameForWell = function(well, schema)
	{
		var indexSet = painter.barcodeVariant.indexSets[well.column];
		var cls = '';
		var lib = well.extract;
		
		if (lib)
		{
			if (lib.excludeFromPool)
			{
				cls += ' exclude-from-pool';
			}
			else if (indexSet)
			{
				cls += ' ' + (lib && lib.barcode.modified ? 'bg-modified' : indexSet.color);
			}
			if (lib.flag)
			{
				cls += ' flagged';
			}
			if (!lib.flag && lib.actualVolume < lib.volume)
			{
				cls += ' low-volume';
			}
			if (!painter.plate.isNeoPrep && (lib.libraryFracAdpt == null || lib.libraryFracAdpt > CreatePool.LIBRARY_FRAC_ADPT_LIMIT))
			{
				cls += ' high-adapter';
			}
			if (lib.isYellow)
			{
				cls += ' yellow-specimen';
			}

		}
		else if (indexSet)
		{
			cls += indexSet.color;
		}
		return cls;
	}
	
	painter.getWellText = function(well, schema)
	{
		var text = '';
		var lib = well.extract;
		if (lib)
		{
			var name = lib.name;
			var i = name.indexOf('.m');
			if (i < 0) i = name.indexOf('.lib');
			var mixFactor = lib.mixFactor;
			var displayName = i == -1 ? Strings.encodeTags(name) : Strings.encodeTags(name.substring(0, i+1))+'<br>&nbsp;'+Strings.encodeTags(name.substring(i));
			text += '<div class="lib if-yellow">'+displayName+'</div>';
			text += '<div>';
//			text += '<span class="barcode">'+lib.barcode.name+'</span>';
			text += '<span class="adapter">'+(lib.libraryFracAdpt != null ? lib.libraryFracAdpt + '%' : '—') + '</span>';
			if (lib.molarity != null)
			{
				text += '<span class="molarity">'+Numbers.formatNumber(lib.molarity, 2, 'nM')+'</span>';
			}
			text += '</div>';
			if (!lib.excludeFromPool)
			{
				mark = (lib.volume > lib.actualVolume) ? '*' : '';
				text += '<div>';
				text += '<span class="volume">'+(isFinite(lib.volume) ? Numbers.formatNumber(lib.volume*mixFactor, 1, 'µl'+mark) : '∞')+'</span>';
				if (lib.mixingStrategy == 'fixed' || lib.mixFactor > 1)
				{
					text += '<span class="eb">'+(isFinite(lib.eb) ? Numbers.formatNumber(lib.eb*mixFactor, 1, 'µl') : '-∞')+'</span>';
				}
				else
				{
					text += '<span class="eb">—</span>';
				}
				text += '</div>';
			}
			if (lib.remarks) text += '<div class="remarks">'+ lib.remarks.join('; ') + '</div>';
			if (lib.comment)
			{
				text += '<div class="remarks">'+ lib.comment + '</div>';
			}
		}
		return text;
	}

	return painter;
}();

